/*
 * Decompiled with CFR 0.152.
 */
package fire.pb.event;

import fire.pb.event.Event;
import fire.pb.event.EventHandler;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

public class Poster {
    static Poster poster = new Poster();
    private static ThreadLocal<Poster> threadlocal = new ThreadLocal();
    private Map<Class<? extends Event>, Set<EventHandler>> listenMap = new HashMap<Class<? extends Event>, Set<EventHandler>>();

    public static Poster getPoster() {
        return poster;
    }

    private Poster() {
    }

    public static Poster current() {
        return threadlocal.get();
    }

    private Set<EventHandler> getListeners(Event e) {
        return this.listenMap.get(e.getClass());
    }

    public <T extends Event> boolean listenEvent(EventHandler eh, Class<T> c) {
        Set<EventHandler> ehs = this.listenMap.get(c);
        if (ehs == null) {
            ehs = new HashSet<EventHandler>();
            this.listenMap.put(c, ehs);
        }
        return ehs.add(eh);
    }

    public void dispatchEvent(Event e) {
        Set<EventHandler> ehs = this.getListeners(e);
        if (ehs != null) {
            for (EventHandler eh : ehs) {
                eh.onEvent(e);
            }
        }
    }
}

